local m=120260017
local cm=_G["c"..m]
cm.name="奇异吸引子"
function cm.initial_effect(c)
	--Activate
	local e1=Effect.CreateEffect(c)
	e1:SetCategory(CATEGORY_DRAW)
	e1:SetType(EFFECT_TYPE_ACTIVATE)
	e1:SetCode(EVENT_FREE_CHAIN)
	e1:SetCost(cm.cost)
	e1:SetTarget(cm.target)
	e1:SetOperation(cm.activate)
	c:RegisterEffect(e1)
end
--Activate
function cm.costfilter1(c)
	return c:IsRace(RACE_CYBERSE) and c:IsAbleToGraveAsCost()
end
function cm.costfilter2(c)
	return c:IsLevelAbove(1) and c:IsRace(RACE_CYBERSE) and c:IsAbleToDeckOrExtraAsCost()
end
function cm.costcheck(g)
	return RD.GroupAllCount(g,Card.IsLocation,1,LOCATION_HAND)
		or (g:GetClassCount(Card.GetLevel)==g:GetCount() and RD.GroupAllCount(g,Card.IsLocation,5,LOCATION_GRAVE))
end
function cm.cost(e,tp,eg,ep,ev,re,r,rp,chk)
	local g1=Duel.GetMatchingGroup(cm.costfilter1,tp,LOCATION_HAND,0,nil)
	local g2=Duel.GetMatchingGroup(cm.costfilter2,tp,LOCATION_GRAVE,0,nil)
	if chk==0 then return g1:GetCount()>0 or g2:GetClassCount(Card.GetLevel)>4 end
	local sg
	if g1:GetCount()<1 then
		Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_TODECK)
		sg=g2:Select(tp,5,5,nil)
	elseif g2:GetClassCount(Card.GetLevel)<5 then
		Duel.Hint(HINT_SELECTMSG,tp,HINTMSG_TOGRAVE)
		sg=g1:Select(tp,1,1,nil)
	else
		g1:Merge(g2)
		Duel.Hint(HINT_SELECTMSG,tp,aux.Stringid(m,1))
		sg=g1:SelectSubGroup(tp,cm.costcheck,false,1,5)
	end
	if sg:GetCount()==1 then
		Duel.SendtoGrave(sg,REASON_COST)
	else
		Duel.SendtoDeck(sg,nil,SEQ_DECKSHUFFLE,REASON_COST)
	end
end
function cm.target(e,tp,eg,ep,ev,re,r,rp,chk)
	if chk==0 then return Duel.IsPlayerCanDraw(tp,2) end
	RD.TargetDraw(tp,2)
end
function cm.activate(e,tp,eg,ep,ev,re,r,rp)
	RD.Draw()
	if Duel.GetFlagEffect(tp,m)~=0 then return end
	RD.CreateCannotActivateEffect(e,aux.Stringid(m,2),cm.aclimit,tp,1,0,RESET_PHASE+PHASE_END)
	Duel.RegisterFlagEffect(tp,m,RESET_PHASE+PHASE_END,0,1)
end
function cm.aclimit(e,re,tp)
	local tc=re:GetHandler()
	return re:IsActiveType(TYPE_MONSTER) and not tc:IsRace(RACE_CYBERSE)
end